"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "BooleanEditor", {
    enumerable: true,
    get: function() {
        return BooleanEditor;
    }
});
const _react = /*#__PURE__*/ _interop_require_wildcard(require("react"));
const _f36components = require("@contentful/f36-components");
const _fieldeditorshared = require("@contentful/field-editor-shared");
const _get = /*#__PURE__*/ _interop_require_default(require("lodash/get"));
const _nanoid = require("nanoid");
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function BooleanEditor(props) {
    const { field } = props;
    const options = [
        {
            value: true,
            label: (0, _get.default)(props.parameters, [
                'instance',
                'trueLabel'
            ], 'Yes'),
            id: (0, _nanoid.nanoid)(6)
        },
        {
            value: false,
            label: (0, _get.default)(props.parameters, [
                'instance',
                'falseLabel'
            ], 'No'),
            id: (0, _nanoid.nanoid)(6)
        }
    ];
    return /*#__PURE__*/ _react.createElement(_fieldeditorshared.FieldConnector, {
        debounce: 0,
        field: field,
        isInitiallyDisabled: props.isInitiallyDisabled
    }, ({ disabled, value, setValue })=>{
        const setOption = (value)=>{
            setValue(value === 'true' ? true : false);
        };
        const clearOption = ()=>{
            setValue(null);
        };
        return /*#__PURE__*/ _react.createElement(_f36components.Flex, {
            testId: "boolean-editor",
            alignItems: "center",
            marginTop: "spacingS"
        }, options.map((option)=>{
            const id = [
                'entity',
                field.id,
                field.locale,
                option.value,
                option.id
            ].join('.');
            const checked = value === option.value;
            return /*#__PURE__*/ _react.createElement(_f36components.Flex, {
                marginRight: "spacingM",
                key: id
            }, /*#__PURE__*/ _react.createElement(_f36components.Radio, {
                id: id,
                isDisabled: disabled,
                value: option.value === undefined ? '' : String(option.value),
                isChecked: checked,
                onChange: (e)=>{
                    if (e.target.checked) {
                        setOption(e.target.value);
                    }
                }
            }, option.label));
        }), value !== undefined && /*#__PURE__*/ _react.createElement(_f36components.TextLink, {
            as: "button",
            testId: "boolean-editor-clear",
            isDisabled: disabled,
            onClick: clearOption
        }, "Clear"));
    });
}
BooleanEditor.defaultProps = {
    isInitiallyDisabled: true
};
